#include "testApp.h"
#include "timeControl.h"

#include <vector>
using namespace std;

//--------------------------------------------------------------
void testApp::setup(){
	
	ofSeedRandom(time(NULL));
	
	ofSetVerticalSync(true);
	ofEnableAlphaBlending();	// turn on alpha blending
	
	int numCircles = 200;
	int numGroups = 5;
	
	vector<float> groupSpeed, groupSpeedMax;
	
	player.loadSound("ttv.mp3", true);
	player.play();
	
	// TODO fill in with musical ratios
	groupSpeed.push_back(1);
	groupSpeedMax.push_back(5);

	groupSpeed.push_back(-6);
	groupSpeedMax.push_back(-3);
	
	groupSpeed.push_back(-3);
	groupSpeedMax.push_back(-1.5);
	
	groupSpeed.push_back(2);
	groupSpeedMax.push_back(3);
	
	groupSpeed.push_back(0);
	groupSpeedMax.push_back(2);

	
	// musical synch
	shakeControl.setPoint(0, 0);
	shakeControl.setPoint(38, 0);
	shakeControl.setPoint(39, 10);
	shakeControl.setPoint(40, 10);
	shakeControl.setPoint(41, 0);
//
	shakeControl.setPoint(62, 0);
	shakeControl.setPoint(63, 10);
	shakeControl.setPoint(64, 10);
	shakeControl.setPoint(65, 0);
//
	shakeControl.setPoint(72, 0);
	shakeControl.setPoint(73, 10);
	shakeControl.setPoint(74, 10);
	shakeControl.setPoint(75, 0);
	//
	shakeControl.setPoint(90, 0);
	shakeControl.setPoint(91, 10);
	shakeControl.setPoint(92, 10);
	shakeControl.setPoint(93, 0);
	//
	shakeControl.setPoint(105, 0);
	shakeControl.setPoint(106, 10);
	shakeControl.setPoint(107, 10);
	shakeControl.setPoint(108, 0);
	//
	shakeControl.setPoint(118, 0);
	shakeControl.setPoint(119, 10);
	shakeControl.setPoint(121, 10);
	shakeControl.setPoint(122, 0);
	//
	shakeControl.setPoint(160, 0);
	shakeControl.setPoint(161, 10);
	shakeControl.setPoint(162, 10);
	shakeControl.setPoint(163, 0);
	//
	shakeControl.setPoint(180, 0);
	shakeControl.setPoint(181, 10);
	shakeControl.setPoint(182, 10);
	shakeControl.setPoint(183, 0);
	//
	

	radiusControl.setPoint(0, 5);
	radiusControl.setPoint(114, 5);
	radiusControl.setPoint(115, 10);
	radiusControl.setPoint(122, 10);
	radiusControl.setPoint(123, 5);
	//
	radiusControl.setPoint(169, 5);
	radiusControl.setPoint(170, 10);
	radiusControl.setPoint(171, 10);
	//
	radiusControl.setPoint(189, 10);
	radiusControl.setPoint(190, 15);
	radiusControl.setPoint(191, 15);
	radiusControl.setPoint(192, 10);
	//
	radiusControl.setPoint(201, 10);
	radiusControl.setPoint(202, 30);

	
	// deals w/ multiples
	// this guy has issues...
	speedControl.setPoint(0, 1);
	/*
	speedControl.setPoint(5, 1);
	speedControl.setPoint(10, 1.5);
	speedControl.setPoint(15, 1);
	speedControl.setPoint(30, 1);
	speedControl.setPoint(40, 2);
	speedControl.setPoint(45, 1);
	speedControl.setPoint(55, 1.5);
	speedControl.setPoint(60, 1);
	speedControl.setPoint(140, 1);
	speedControl.setPoint(152, 2);
	speedControl.setPoint(155, 3);
	speedControl.setPoint(170, 3);
	speedControl.setPoint(175, 1);
	*/
	
	for(int g=0; g<numGroups; ++g) {
		
		ofColor drawColor;
		drawColor.r = ofRandom(0, 255);
		drawColor.g = ofRandom(0, 255);
		drawColor.b = ofRandom(0, 255);
		drawColor.a = 255;
		
		ofColor colorSpeed;
		colorSpeed.r = ofRandom(0, .5);
		colorSpeed.g = ofRandom(0, .5);
		colorSpeed.b = ofRandom(0, .5);
		colorSpeed.a = ofRandom(0, .1);
		
		int circleRange = numCircles/numGroups;
		for(int c=0; c<circleRange; ++c) {
		
			float drawRadius			= 5;
			
			float rotationRadius	= ofMap(c, 0, circleRange, 0, min(ofGetWidth()/2, ofGetHeight()/2)); 
			
			ofPoint origin(ofGetWidth()/2, ofGetHeight()/2);
			
			float rotationSpeed		= ofMap(c, 0, circleRange, groupSpeed[g], groupSpeedMax[g]); 
			
			float RRModulation		= .2;

			float angleOffset			= 2 * M_PI * g / numGroups;
		
			points.push_back(WhitneyPoint(drawRadius,
																		rotationRadius,
																		origin,
																		rotationSpeed,
																		RRModulation,
																		drawColor,
																		colorSpeed,
																		angleOffset));
		}
	}
}

//--------------------------------------------------------------
void testApp::update(){
	vector<WhitneyPoint>::iterator it = points.begin();
	for(it; it!=points.end(); ++it) {
		it->update();
		
		it->setShake(shakeControl.getCurrentValue());
		it->setRadius(radiusControl.getCurrentValue());
		it->setSpeedRatio(speedControl.getCurrentValue());
		printf("speed ratio is %f\n", speedControl.getCurrentValue());
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	ofBackground(0, 0, 0);
	
	vector<WhitneyPoint>::iterator it = points.begin();
	for(it; it!=points.end(); ++it) {
		it->draw();
	}
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){
	
}

