/*
 *  point.h
 *  johnWhitney
 *
 *  Created by Lucas Vickers on 9/20/10.
 *  Copyright 2010 None. All rights reserved.
 *
 */

#ifndef WHITNEY_POINT_H
#define WHITNEY_POINT_H

#include "ofMain.h"

class WhitneyPoint
{

protected:
	float drawRadius;			// how big is the circle we draw
	float rotationRadius;	// orbital radius
	ofPoint origin;			// where do we rotate around
	ofPoint currentOrigin;	// we can shake the origin
	float rotationSpeed;	// speed at which we rotate.  independent of screen speed as it works off of the runtime
	float curRotationSpeed;
	ofPoint curLocation;	// current location
	
	// more advanced cool stuff
	float RRModulation;		// rotationRadius amplitude modulation
	ofColor color;			// currentColor
	ofColor colorSpeed;		// color will change based on these values and the sin movement
	ofColor curColor;			// updated color
	float angleOffset;		// cause point to be offset
	
	
public:
	WhitneyPoint(float drawRadius, 
				 float rotationRadius, 
				 ofPoint origin, 
				 float rotationSpeed,
				 float RRModulation,
				 ofColor color,
				 ofColor colorSpeed,
				 float angleOffset);
	
	void update();
	void draw();
	void setShake(float shakeRadius);
	void setRadius(float setRadius);
	void setSpeedRatio(float ratio);
	
};

#endif
